// ConsoleApplicationMemoryDetection.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int Sum(int n)
{

	if (n > 7) throw range_error("Sum(n), n < 8");

	return n * (n + 1) / 2;
}

int main()
{
	MemLeakCheck(anything);
	
	// NEVER use raw pointer in C++
	// int *ptr = new int[10];
	

	try
	{
		std::unique_ptr<int[]> uptr(new int[10]);

		for (int i = 0; i < 10; ++i)
		{
			uptr[i] = Sum(i + 1);

			cout << "(" << (i + 1) << ", " << uptr[i] << ") ";
		}
	}
	catch (range_error& e)
	{
	}

	cout << endl;
	
	return 0;
}

